#include "living.h"

static object myself;	/* this object */
int intoxicated;        /* How many ticks to stay intoxicated. */
int stoned;             /* "    "    "    "   "   stoned       */
int stomach;            /* "    "    "    "  have a full stomach */
int hard_invis;
int headache, max_headache;

string it;              /* Last thing referenced. */
static int PWR;         /* global power-variable */
static object from;     /* to store last position of this creature */

/*
 * Some stuff for combat spells and magical moves
 */
static int fx_pending;
static object fx_room;
static object fx_1st;
static object fx_2nd;
static int fx_pos;
static int fx_depth;

/* Some functions to set moving messages. */

setmout(m) { msgout = m; return 1; }
setmin(m) { msgin = m; return 1; }
setmmout(m) { mmsgout = m; return 1; }
setmmin(m) { mmsgin = m; return 1; }

review() {
  write("exit: "+msgout+"\n"+
        "entrance: "+msgin+"\n"+
        "magic exit: "+mmsgout+"\n"+
        "magic entrance: "+mmsgin+"\n");
  return 1;
}

query_msgin() { return msgin; }
query_msgout() { return msgout; }
query_mmsgin() { return mmsgin; }
query_mmsgout() { return mmsgout; }


set_from() {
    from = environment(myself);
}

query_from() {
    return from;
}

reset(arg) {
  ::reset(arg);
  if (arg) {
    return;
  }
  set_heart_beat(1);
  myself = this_object();
  level = -1;
  msgin = "arrives"; msgout = "leaves";
  mmsgin = "slowly shimmers into sight";
  mmsgout = "slowly dissolves before your eyes";
  fx_pending = 0;
}

/* Enable other objects to query our hit point. */
query_hit_point() {
  return hit_point;
}

query_age() { return age; }

query_shape() {
  if (hit_point < max_hp/10)
    return (capitalize(query_pronoun()) + " looks like a total mess.");
  if (hit_point < max_hp/5)
    return (capitalize(query_pronoun()) + " is in bad shape.");
  if (hit_point < max_hp/2)
    return (capitalize(query_pronoun()) + " is not in a good shape.");
  if (hit_point < max_hp - 20)
    return (capitalize(query_pronoun()) + " is slightly hurt.");
  return (capitalize(query_pronoun()) + " is in prime shape.");
}

/* Identify ourself. */
id(str) { return str == name; }

set_level(lev) {
    level = lev;
    max_hp = 42 + level * 10;
}

add_commands() {
    add_action("give_object", "give");
    add_action("put", "put");
    add_action("pick_up", "get");
    add_action("pick_up", "take");
    add_action("drop_thing", "drop");
    add_action("communicate", "say");
    add_action("tell", "tell");
    add_action("whisper", "whisper");
    add_action("scorch","scorch");
    add_action("shoot","shoot");
}

/*  We don't need kill
kill(str) {
  object ob;
  if (!str) {
    write("Kill what ?");
    return 1;
  }
  ob = present(lower_case(str), environment(this_player()));
  if (!ob) {
    write("No "+str+" here !\n");
    return 1;
  }
  if (!living(ob)) {
    write(str+" is not a living thing, you silly!\n");
    say(cap_name+" tries foolishly to attack "+str+".\n");
    return 1;
  }
  if (ob == this_object()) {
    write("Please... no SM, OK?\n");
    return 1;
  }
  if (attacker_ob == ob) {
    write("Yes, yes.\n");
    return 1;
  }
  if (attacker_ob) {
    if (!ob->query_ghost()) {
      if (!alt_attacker_ob || alt_attacker_ob == ob)
        alt_attacker_ob = attacker_ob;
      attacker_ob = ob;
    }
  } else {
    attack_object(ob);
  }
  return 1;
}

*/
/* multiple line 'say' done by Orion 23-4-1992 */
communicate(str) {
  string dummy, temp;
  if (!str) {
    write("Say what ?\n");
    say(cap_name+" stutters.\n");
    return 1;
  }
  str=check_message(str);
  while(strlen(str+cap_name)>71) {
    temp="";
    dummy="";
    while(strlen(temp+dummy+cap_name)<72) {
      if(temp=="") {
        temp=dummy;
      } else {
        temp+=" "+dummy;
      }
      dummy="";
      if(sscanf(str,"%s %s",dummy,str)!=2) {
        dummy=str;
        str="";
      }
    }
    say(cap_name+" says: "+temp+"\n");
    write("You say: "+temp+"\n");
    if(strlen(dummy)>70) {
      say(cap_name+" says: "+dummy+"\n");
      write("You say: "+dummy+"\n");
      dummy="";
    }
    if(dummy!="") str=dummy+" "+str;
  }
  say(cap_name+" says: "+str+"\n");
  write("You say: "+str+"\n");
  return 1;
}

heart_beat() {
  age += 1;
  if (intoxicated && random(40) == 0) {
    int n;
    n = random(7);
    if (n == 0) {
      say(cap_name + " hiccups.\n");
      write("You hiccup.\n");
    }
    if (n == 1) {
      say(cap_name+" seems to fall, but takes a step and recovers.\n");
      write("You stumble.\n");
    }
    if (n == 3) {
      write("You feel drunk.\n");
      say(cap_name+" looks drunk.\n");
    }
    if (n == 5) {
      say(cap_name+" burps.\n");
      write("You burp.\n");
    }
  }
  if (hit_point < max_hp || spell_points < (max_hp*2) || intoxicated || headache
      || stomach || stoned)
  {
    time_to_heal -= 1;
    if (1) {   /* was: if (time_to_heal < 0) { , but we shall always heal */
      if (stoned) {
        stoned--;
        if (!stoned) tell_object(myself,"You are not stoned anymore.\n");
      }
      if (stomach) {
        stomach--;
        if (!stomach) tell_object(myself,"You feel like eating again.\n");
      }
      if (headache) {
        headache -= 1;
        if (headache == 0)
        tell_object(myself, "You no longer have a head ache.\n");
      }
      if (hit_point < max_hp) {
        if(1) {     /* was: if(time_to_heal < 0) { */
          hit_point +=1; /* hp shouldn't go faster */
          if (intoxicated)
            hit_point += 3;
        }
        if (hit_point > max_hp)
          hit_point = max_hp;
      }
      if (spell_points < (max_hp*2)) {
        spell_points += 8;
        if (intoxicated)
          spell_points += 16;
        if (spell_points > (max_hp*2))
          spell_points = (max_hp*2);
      }
      if (intoxicated) {
        intoxicated -= 1;
        if (intoxicated == 0) {
          headache = max_headache;
          max_headache = 0;
          tell_object(myself,
                      "You suddenly without reason get a bad head ache.\n");
          hit_point -= 3;
          if (hit_point < 0)
            hit_point = 0;
        }
      }
      time_to_heal = INTERVAL_BETWEEN_HEALING;
    }
  }
  if (attacker_ob)
    attack();
  if (attacker_ob && whimpy && hit_point < max_hp/5 && random(200) > brave)
  if (random(dex) < 10 && !is_npc)        
    tell_object(this_object(), "Due to the lack of dexterity you fail to run away!\n");
  else
    run_away();
}

add_drug(n) {
  if (!intp(n)) return;
  stoned += 5*n;
  if (stoned < 0) stoned = 0;
}

add_food(n) {
  if (!intp(n)) return;
  stomach += 3*n;
  if (stomach< 0) stomach = 0;
}

query_hungry() { return stomach <= level/2; }
query_stoned() { return stoned > level/2; }

set_al(a) {
  alignment = a;
}

set_wc(a) {
  if (!intp(a)) {
    write("Wrong argument to set_wc.\n");
    return 1;
  }
  weapon_class = a;
  /* set min/maximim */
  if (weapon_class > 100) weapon_class = 100;
  if (weapon_class < 0) weapon_class = 0;
  return;
}

set_ac(a) {
  if (!intp(a)) {
    write("Wrong argument in set_ac.\n");
    return;
  }
  armour_class = a;
  if (armour_class > 100) armour_class = 100;
  if (armour_class < 0) armour_class = 0;
  return;
}

static test_dark() {
  return 0;
}

put(str) {
  int i;
  string item;
  string container;
  object item_o;
  object container_o;

  if (!str)
    return 0;
  if (test_dark())
    return 1;
  if (sscanf(str, "%s in %s", item, container) != 2) {
    write("put what ?\n");
    return 1;
  }
  container = lower_case(container);
  container_o = present(container, this_player());
  if (!container_o)
    container_o = present(container, environment(this_player()));
  if (!container_o) {
    write("There are no " + container + "s here!\n");
    return 1;
  }
  if (!call_other(container_o, "can_put_and_get", 0)) {
    write("You can't do that.\n");
    return 1;
  }
  item = lower_case(item);
  item_o = present(item, this_player());
  if (!item_o) {
    write("You have no " + item + "!\n");
    return 1;
  }
  if (item_o == container_o)
    return 0;
  if (call_other(item_o, "prevent_insert"))
    return 1;
  if (call_other(item_o, "drop"))
    return 1;
  i = call_other(item_o, "query_weight");
  if (call_other(container_o, "add_weight", i)) {
    /* Remove the weight from the previous container. */
    call_other(environment(item_o), "add_weight", -i);
    move_object(item_o, container_o);
    log_corpse(item_o);
    say(cap_name+" puts the "+item+" in the "+container+".\n");
    write("Ok.\n");
    it = item;
    return 1;
    }
    write("There is not room for more.\n");
    return 1;
}

log_corpse(obj) {
  string killer;

  if (!obj->id("corpse") || !(killer = obj->query_killed_by()))
    return;
}

pick_up(str) {
  string item;
  string container;
  object item_o;
  object container_o;
  int weight,pwr;

  if (!str) {
    write("What do you want to pick up?\n");
    return 1;
  }
  pwr = 0;
  PWR = 0;   /* GLOBAL */
  if (test_dark())
    return 1;
  if ((str == "all") || (str == "! all")) {
    if ((str == "! all") && (level > 19)) PWR = 1;
    get_all(environment());
    PWR = 0;
    return 1;
  }
  if ((sscanf(str, "! %s from %s", item, container) == 2) && (level>19))
    pwr = 1;
  if (!pwr) {
    if (sscanf(str, "%s from %s", item, container) != 2) {
      pick_item(str);
      return 1;
    }
  }
  container_o = present(lower_case(container));
  if (!container_o) {
    write("There is no " + container + " here.\n");
    return 1;
  }
  if (!call_other(container_o, "can_put_and_get", 0) && !pwr) {
    write("You can't do that!\n");
    return 1;
  }
  item_o = present(item, container_o);
  if (!item_o){
    write("There is no " + item + " in the " + container + ".\n");
    return 1;
  }
  if (!call_other(item_o, "get", item) && !pwr) {
    write("You can not take "+item+" from "+container+".\n");
    return 1;
  }
  weight = call_other(item_o, "query_weight", 0);
  if (!add_weight(weight)) {
    write("You can not carry more.\n");
    return 1;
  }
  log_corpse(container_o);
  call_other(container_o, "add_weight", -weight);
  move_object(item_o, myself);
  say(cap_name + " takes " + item + " from " + container + ".\n");
  return 1;
}

pick_item(obj) {
  object ob;
  int i,pwr;
  pwr = 0;
  if ((sscanf(obj, "! %s", obj) == 1) && (level>19))
    pwr = 1;
  obj = lower_case(obj);
  ob = present(obj, environment(this_player()));
  if (!ob) {
    write("That is not here.\n");
    return 1;
  }
  if (environment(ob) == myself) {
    write("You already have it!\n");
    return 1;
  }
  if ((call_other(ob, "get", 0) == 0) && !pwr) {
    write("You can not take that!\n");
    return 1;
  }
  i = call_other(ob, "query_weight", 0);
  if (add_weight(i)) {
    move_object(ob, myself);
    say("@RMO"+ob->query_idstr()+".@RFS");
    write("@RMO"+ob->query_idstr()+".@RFS");
    say(cap_name+" takes "+obj+"\n");
    log_corpse(ob);
    it = obj;
    return 1;
  }
  write("You can't carry that much.\n");
  return 1;
}

drop_thing(obj) {
  string tmp;
  string tmp2,power;
  int i;
  if (!obj) {
    write("What do you want to drop down?\n");
    return 1;
  }

  PWR = 0;
  if (sscanf(obj, "! %s", power) == 1)
    if (level > 19) {
      PWR = 1;
      obj = power;
    }
  if (obj == "all") {
    drop_all(1);
    return 1;
  }
  if (sscanf(obj, "%s in %s", tmp, tmp2) == 2) {
    put(obj);
    return 1;
  }
  if (obj == "money" || obj == "all money") {
    drop_all_money(1);
    return 1;
  }
  tmp = obj;
  obj = present(lower_case(obj), this_player());
  if (!obj) {
    write("You do not hold such an item.\n");
    return 1;
  }
  if (drop_one_item(obj) ) {
    say(call_other(obj,"query_desc")+"@RFS");
    write(call_other(obj,"query_desc")+"@RFS");
    say(cap_name + " drops the "+tmp+".\n");
  }
  PWR = 0;
  return 1;
}

add_weight(w) {
  int max;

  max = level + 10;
  if (frog)
    max = max / 2;
  if (w + local_weight > max)
    return 0;
  if(w + local_weight < 0)
    return 0;
  local_weight += w;
  return 1;
}

tell(str) {
  object ob;
  string who;
  string msg;

  if (!str || sscanf(str, "%s %s", who, msg) != 2) {
    write("Tell what ?\n");
    return 1;
  }
  it = lower_case(who);
  ob = find_player(it);
  if (!ob) ob = find_living(it);
  if (!ob || (ob->query_invis() && level < 20)) {
    write("No player with that name.\n");
    return 1;
  }
  if (!query_ip_number(ob) && !ob->query_npc())
    write("This player is link-dead!\n");
  if (ob->query_busy() && level < 20) {
    write(ob->query_name() + " is busy now and doesn't want to be disturbed.\n");
    return 1;
  }
  if (level < 20 && !is_npc)
    spell_points -= 5;
  msg=check_message(msg);
  tell_object(ob, cap_name + " tells you: " + msg + "\n");
  write("Ok.\n");
  return 1;
}

whisper(str) {
  object ob;
  string who;
  string msg;
  if (!str || sscanf(str, "%s %s", who, msg) != 2) {
    write("Whisper what ?\n");
    return 1;
  }
  it = lower_case(who);
  ob = find_living(it);
  if (!ob || !present(it, environment(this_player()))) {
    write("No player with that name in this room.\n");
    return 1;
  }
  if (ob->query_busy() && level < 20) {
    write(ob->query_name() + " is busy now and doesn't want to be disturbed.\n");
    return 1;
  }
  msg=check_message(msg);
  tell_object(ob,  cap_name + " whispers to you: " + msg + "\n");
  write("Ok.\n");
  say(cap_name + " whispers something to " + who + ".\n", ob);
  return 1;
}

/*
 * This routine is called from other routines to drop one specified object.
 * We return true if success.
 */

drop_one_item(ob) {
  int weight, stat;
   
  stat = call_other(ob, "drop", 0);
  if (stat == 1 && !PWR)
    return 0;
  weight = call_other(ob, "query_weight", 0);
  if (!weight)
    weight = 0;
  add_weight(-weight);
  /*
   * Give object same pos/depth as creature dropping it.
   */
  ob->locate(pos,depth);
  move_object(ob, environment(myself));
  if (stat == -1) destruct(ob);
  return 1;
}

drop_all(verbose) {
  object ob;
  object next_ob;
  if (!myself || !living(myself))
    return;
  ob = first_inventory(myself);
  while(ob) {
    string out;
    next_ob = next_inventory(ob);
    it = call_other(ob, "short", 0);
    if (drop_one_item(ob)) {
      say(call_other(ob,"query_desc"));
      write(call_other(ob,"query_desc"));
      out = it + ".\n";
      say(cap_name+" drops "+out);
      tell_object(myself, "drop: "+out);
    }
    ob = next_ob;
  }
  say("@RFS");
  write("@RFS");
}

add_exp(e) {
  experience += e;
}

add_intoxination(i) {
  intoxicated += i;
  if(intoxicated < 0)
    intoxicated = 0;
}

query_intoxination() {
  return intoxicated;
}

drink_alcohol(strength) {
  if ((intoxicated > level + 3) && strength >=0) {
    write("You fail to reach the drink with your mouth.\n");
    return 0;
  }
  if (social<100 && strength >= 0) 
    social = social + ((100-social)/40);
  intoxicated += strength;
  if (intoxicated < 0)
    intoxicated = 0;
  if (intoxicated == 0)
    write("You are completely sober.\n");
  if (intoxicated > 0 && headache) {
    headache = 0;
    tell_object(myself, "Your head ache disappears.\n");
  }
  if (intoxicated > max_headache)
    max_headache = intoxicated;
  if (max_headache > 8)
    max_headache = 8;
  return 1;
}

check_point() { /* dummy */ }

give_object(str) {
  string item, dest;
  object item_ob, dest_ob;
  int weight;
  int coins;

  if (!str)
    return 0;
  if (test_dark())
    return 1;
  if (sscanf(str, "%d credits to %s", coins, dest) == 2)
    item = 0;
  else if ( sscanf(str, "1 credit to %s", dest) == 1)
    coins = 1;
  else if ( sscanf(str, "credit to %s", dest) == 1)
    coins = 1;
  else if (sscanf(str, "one credit to %s", dest) == 1)
    coins = 1;
  else if (sscanf(str, "%s to %s", item, dest) != 2) {
    write("Give what to whom ?\n");
    return 1;
  }
  dest = lower_case(dest);
  if (item) {
    item = lower_case(item);
    item_ob = present(item, this_player());
    if (!item_ob) {
      write("There are no " + item + " here.\n");
      return 1;
    }
    it = item;
    if (environment(item_ob) == this_object() &&
        call_other(item_ob, "drop", 0) == 1) {
      return 1;
    } else {
      if (!call_other(item_ob, "get")) {
        write("You can't get that !\n");
        return 1;
      }
    }
  }
  dest_ob = present(dest, environment(this_player()));
  if (!dest_ob) {
    write("There is no " + capitalize(dest) + " here.\n");
    return 1;
  }
  if (!living(dest_ob)) {
    write("You can't do that.\n");
    return 1;
  }
  if (!item) {
    if (coins <= 0 && level < 20)
      return 0;
    if (money < coins) {
      write("You don't have that much money.\n");
      return 1;
    }
    money -= coins;
    /* Checkpoint the character, to prevent cheating */
    if (coins > 1000 && level < 20)
      check_point();
    call_other(dest_ob, "add_money", coins);
    tell_object(dest_ob, cap_name+" gives you "+coins+" credits.\n");
    say(cap_name + " gives some credits to "+dest_ob->query_name()+".\n",dest_ob);
    write("Ok.\n");
    return 1;
  }
  weight = call_other(item_ob, "query_weight", 0);
  if (!call_other(dest_ob, "add_weight", weight)) {
    write("" + capitalize(dest) + " can't carry any more.\n");
    return 1;
  }
  add_weight(-weight);
  move_object(item_ob, dest_ob);
  say("" + cap_name + " gives " + item + " to " + capitalize(dest) + ".\n");
  write("Ok.\n");
  return 1;
}

/*
 * Get all items here.
 */
static get_all(from) {
  object ob, next_ob;

  ob = first_inventory(from);
  while (ob) {
    string item;
    next_ob = next_inventory(ob);
    if (ob != this_player()) {
      item = call_other(ob, "short", 0);
      if (item && call_other(ob, "get", 0) || PWR) {
        int weight;
        weight = call_other(ob, "query_weight", 0);
        if (add_weight(weight)) {
          write(item + ": Ok. ");
          move_object(ob, this_object());
          log_corpse(ob);
          tell_room(from,"@RMO"+ob->query_idstr()+".");
          say(cap_name+" takes: "+item+".\n");
        } else {
          write(item + ": Too heavy. ");
        }
        it = item;
      }
    }
    ob = next_ob;
  }
  tell_room(from,"@RFS");
}

invis()
{
  if (is_invis) {
    tell_object(this_object(), "You are already invisible.\n");
    return 1;
  }
  is_invis = 1;
  if (!hard_invis || level < 24)
    tell_object(this_object(), "You are now invisible.\n");
  else {
    tell_object(this_object(), "You are now HARD invisible!\n");
    log_file("HARD_INVIS", name + "("+level+") has gone hard-invisible at "+ctime(time())+"\n");
  }
  say("" + cap_name +" "+ mmsgout + ".\n", this_object());
  say("@RMO"+idstr+"@RFS",this_object());
  write("@RMO"+idstr+"@RFS");
  cap_name = "Someone";
  return 1;
}

vis() {
  if (level >= 24 && this_object() != this_player()) return;
  if (!is_invis) {
    tell_object(this_object(), "You are not invisible.\n");
    return 1;
  }
  is_invis = 0;
  tell_object(this_object(), "You are now visible.\n");
  if (hard_invis && level > 23)
    tell_object(this_object(), "Hard invisibility mode still active!\n");
  cap_name = capitalize(name);
  say(cap_name + " " + mmsgin + ".\n", this_object());
  say(this_object()->query_desc()+"@RFS",this_object());
  write(this_object()->query_desc()+"@RFS");
  return 1;
}

query_invis() { return is_invis; }

query_real_name() {
  if (!is_invis || level < 24 || !hard_invis) return name;
  if (!this_player() || !query_ip_number(this_player()) 
     || this_player()->query_level() < 24) return "someone";
  return name;
}

/* A creature is never normally picked up by other players, but wizards
 * can do anything. Thus, if a player is dropped, the local weight
 * would be scrambled.
 */
drop() {
  return 1;
}

/*
 * Code for strolling along the countryside (or whatever)
 */

check_position_bounds() {
  object old_env;

  if (depth>7) {
    old_env = environment(myself);
    depth = 0;
    command("north micro");
    if (old_env == environment(myself))
      depth = 7;
    return;
  }
  if (depth<0) {
    old_env = environment(myself);
    depth = 7;
    command("south micro");
    if (old_env == environment(myself))
      depth = 0;
    return;
  }
  if (pos>15) {
    old_env = environment(myself);
    pos = 0;
    command("east micro");
    if (old_env == environment(myself))
      pos = 15;
    return;
  }
  if (pos<0) {
    old_env = environment(myself);
    pos= 15;
    command("west micro");
    if (old_env == environment(myself))
      pos = 0;
    return;
  }
  /* OK, appearantly we moved, but stayed inside location! */
  if(!this_object()->query_invis())
    tell_room(environment(myself),"@RMO"+idstr+"."+query_desc()+"@RFS");
}

micro_n() {
  depth++;
  check_position_bounds();
  return 1;
}

micro_s() {
  depth--;
  check_position_bounds();
  return 1;
}

micro_e() {
  pos++;
  check_position_bounds();
  return 1;
}

micro_w() {
  pos--;
  check_position_bounds();
  return 1;
}

scorch() {
  object r;

  if (fx_pending) {
    write("Yes, I am trying, have patience.\n");
    return 1;
  }
  fx_pending = 1;
  fx_room = environment(this_object());
  fx_1st = "dummies/burst1";
  fx_2nd = "dummies/burst2";
  fx_pos = 4;
  fx_depth = 4;
  call_out("fx_stage1",2,"");
  call_out("fx_stage2",4,"");
  call_out("fx_stage3",6,"");

  say(cap_name+" concentrates energy.\n");
  write("Ok.\n");
  return 1;
}

fx_stage1() {
  tell_room(fx_room,"@VIO"+fx_1st+"."+sendhex(fx_pos)+sendhex(fx_depth)+"@RFS");
}

fx_stage2() {
  tell_room(fx_room,"@RMO"+fx_1st+".@VIO"+fx_2nd+"."+sendhex(fx_pos)+sendhex(fx_depth)+"@RFS");
}

fx_stage3() {
  tell_room(fx_room,"@RMO"+fx_2nd+".@RFS");
  fx_pending = 0;
}


magic_move(dest) {
  object r;

  r = environment(this_object());
  ::magic_move(dest);
  if(is_invis) return;
  if (fx_pending) return;
  fx_pending = 1;
  fx_room = r;
  fx_1st = "dummies/cloud1";
  fx_2nd = "dummies/cloud2";
  fx_pos = pos;
  fx_depth = depth;
  call_out("fx_stage1",2,"");
  call_out("fx_stage2",4,"");
  call_out("fx_stage3",6,"");
}

shoot(str) {
  object ob;

  if (!str) {
    write("Shoot what ?");
    return 1;
  }
  ob = present(lower_case(str), environment(this_player()));
  if (!ob) {
    write("No "+str+" here !\n");
    return 1;
  }
  if (!living(ob)) {
    write(str+" is not a living thing, you silly!\n");
    say(cap_name+" tries foolishly to shoot "+str+".\n");
    return 1;
  }
  if (ob == this_object()) {
    write("Please... no SM, OK?\n");
    return 1;
  }
  call_other("system/combat","shoot",pos,depth,
             ob->query_pos(), ob->query_depth(), "dummies/bullet");
  return 1;
}

check_message(str) {
	string dummy,what;
	str=check_message2(str,"@DFS");
	str=check_message2(str,"@SCE");
	str=check_message2(str,"@RFS");
	str=check_message2(str,"@RQV");
	str=check_message2(str,"@DFO");
	str=check_message2(str,"@VIO");
	str=check_message2(str,"@RMO");
	str=check_message2(str,"@TMS");
	str=check_message2(str,"@PUR");
	str=check_message2(str,"@DFS");
	if(sscanf(str,"%s#RQO%s",str,what)==2)
		command("#RQO"+what,this_player());
	if(sscanf(str,"%s#RQS%s",str,what)==2)
		command("#RQS"+what,this_player());
	return str;
}
check_message2(str,remove) {
	string dummy;
	sscanf(str,"%s"+remove+"%s",str,dummy);
	if(dummy) str=str+dummy;
	return str;
}
