/* Less version 1.1 (slightly improved)
   (c) by Morgan (groenewo@fwi.uva.nl) 18/May/1991

   Existing features:  d    down half page
                       u    up half page
                       q    quit (phew!)
   Added features:     b    back full page
                       f    forward full page
                   a | bb   backward two pages
                   z | ff   forward two pages
                       r    repaint screen
                       g    goto first line
                     <nr>   goto line <nr>

   Known bug: When EOF is reached, the linenumber printed is
              generally wrong (too high).
*/
#define CHUNK 11
#define SCRSIZE 24
#define FROMDIR "/players/morgan/obj"
#define SHORTMSG "Lesser object v1.1 by Morgan.\n"

string file;
int line, move, goline;

reset(arg) {
}

id(str) {
    return str == "less" || str == "lesser";
}

short() {
    return "Lesser object";
}

long() {
    write("Less utility. For more info: less ?\n");
}

init() {
    if(environment(this_object()) == this_player()) {
      write(SHORTMSG);
    }
  if (this_player()->query_level() > 19) {
    add_action("less", "less");
  }
}

try(file) {
  int i;

  write("file_size: "+file_size(file)+".\n");
  write("Counting...\n");
  for(i=0;;i++) {
    if(cat(file,i,0)==0) write("EOF at "+i+".\n");
    return;
  }
}

input(str) {
  if (sscanf(str, "%d", goline) == 1) {
    line = goline;
    move = CHUNK;
  }
  else if(str == "try") {
    write("Calling try()...\n");
    try(file);
  }
  else {
    if (str == "ff" || str == "a")
      move = 4*CHUNK;
    else if (str == "bb" || str == "z")
      move = -4*CHUNK;
    else if (str == "r") {
      line -= SCRSIZE;
      move = SCRSIZE;
    }
    else if (str == "g") {
      line = 1;
      move = CHUNK;
    }
    else if (str == " " || str == "f")
      move = CHUNK + CHUNK;
    else if (str == "b" )
      move = -CHUNK - CHUNK;
    else if (str == "" || str == "d")
      move = CHUNK;
    else if (str == "u")
      move = -CHUNK;
    else if (str == "q") {
        write("Ok.\n");
        return;
    }
  }
    if(move < 0) {
      line += move + move;
      move = -move;
    }
    if (line < 1) line = 1;
    if (cat(file, line, move) == 0) {
        file = 0;
        write("EOF\n");
        return;
    }
    line += move;
    write(line + " Less: ");
    input_to("input");
}

less(str) {
  if (!str) {
    write(SHORTMSG);
    write ("  Usage: less <filename>\n");
    write ("  Help:  less ?\n");
    write ("\n");
    return(1);
  }
  else if (str == "?") {
    write(SHORTMSG);
    write ("  Usage: less <filename>\n");
    write ("\n");
    write ("  Options:  u    up half page\n");
    write ("            d    down half page\n");
    write ("            b    back full page\n");
    write ("            f    forward full page\n");
    write ("        a | bb   backward two pages\n");
    write ("        z | ff   forward two pages\n");
    write ("            g    goto line 1\n");
    write ("            r    repaint screen\n");
    write ("          <nr>   goto line <nr>\n");
    write ("\n");
    return(1);
  }
    if (extract(str,0,0) == "/")
      file = str;
    else {
      file = "/" + str;
      if (this_player()->query_path() != "")
        file = "/" + this_player()->query_path() + file;
    }
    line = 1;
    if (cat(file, line, CHUNK) == 0) {
        write("File " + file + " not found.\n");
        return 1;
    }
    line += CHUNK;
    input_to("input");
    write(CHUNK + 1 + "\t" + str + " Less: ");
    return 1;
}

get() {
    return 1;
}

init_arg() {
}
query_value() { return 20; }
query_auto_load() { return FROMDIR + "/less:0"; }
drop () { return 1; }
