inherit "obj/xthing";

#define WEAPON_CLASS_OF_HANDS           (3)
#define KILL_NEUTRAL_ALIGNMENT          10
#define ADJ_ALIGNMENT(al)               ((-al - KILL_NEUTRAL_ALIGNMENT)/4)
#define NAME_OF_GHOST                   "some mist"
#define LOG_FLAGS

/*
 * Do NOT copy this .c file!
 * Use inheritance / cloning instead.
 *
 * This living.c file has been adapted for use with BSX by Bram Stolk.
 * Include this file in objects that "live".
 * The following variables are defined here:
 *
 */

int time_to_heal;               /* Count down variable. */
int money;                      /* Amount of money on player. */
string name;                    /* Name of object. */
string msgin, msgout;           /* Messages when entering or leaving a room. */
static int is_npc;
int brief;
int level;                      /* Level of monster. */
int armour_class;               /* What armour class of monster. */
int hit_point;                  /* Number of hit points of monster. */
int max_hp;
int experience;                 /* Experience points of monster. */
string mmsgout;                 /* Message when leaving magically. */
string mmsgin;                  /* Message when arriving magically. */
static object attacker_ob;      /* Name of player attacking us. */
static object alt_attacker_ob;  /* Name of other player also attacking us. */
int weapon_class;               /* How good weapon. Used to calculate damage.*/
static object name_of_weapon;   /* To see if we are wielding a weapon. */
static object head_armour;      /* What armour we have. */
int ghost;                      /* Used for monsters that can leave a ghost. */
int local_weight;               /* weight of items */
static object hunted, hunter;   /* used in the hunt mode */
static int hunting_time;        /* How long we will stay in hunting mode. */
string cap_name;                /* Capital version of "name". */
int spell_points;               /* Current spell points. Same max as max_hp. */
static string spell_name, spell_file;
static int spell_cost, spell_dam;
int age;                        /* Number of heart beats of this character. */
int is_invis;                   /* True when player is invisible */
int frog;                       /* If the player is a frog */
int whimpy;                     /* Automatically run when low on HP */
string auto_load;               /* Special automatically loaded objects. */
string flags;                   /* a bit string */
int dead;                       /* Are we alive or dead? */

int alignment;                  /* Are we good or evil? */
int gender;                     /* Are we male, female or neither? */

/* All characters have attributes */
int strength, tough, intel, dex, brave, social;

/*
 * The following routines are defined for usage:
 * stop_fight           Stop a fight. Good for scroll of taming etc.
 * hit_player           Called when fighting.
 * transfer_all_to:     Transfer all objects to dest.
 * move_player:         Called by the object that moves the monster.
 * query_name:          Gives the name to external objects.
 * attacked_by          Tells us who are attacking us.
 * show_stats           Dump local status.
 * stop_wielding        Called when we drop a weapon.
 * stop_wearing         Called when we drop an armour.
 * query_level          Give our level to external objects.
 * query_value          Always return 0. Can't sell this object.
 * query_npc            Return 1 if npc otherwise 0.
 * get                  Always return 0. Can't take this object.
 * attack               Should be called from heart_beat. Will maintain attack.
 * query_attack
 * drop_all_money       Used when the object dies.
 * wield                Called by weapons.
 * query_wielded        To find out if and which weapon is wielded
 * query_head_armour    return head_armour
 * wear                 Called by armour.
 * add_weight           Used when picking up things.
 * heal_self            Enable wizards to heal this object.
 * can_put_and_get      Can look at inventory, but not take things from it.
 * attack_object        Called when starting to attack an object.
 * test_if_any_here     For monsters. Call this one if you suspect no enemy
 *                      is here any more.
 *                      Return 1 if anyone there, 0 if none.
 * force_us             Force us to do a command.
 * query_spell_points   Return how much spell points the character has.
 * reduce_hit_point     Reduce hit points, but not below 0.
 */

/* Added to reset the xthing inheritance */
reset(arg) {
  ::reset(arg);
}

/*
 * This routine is called from objects that moves the player.
 * Special: direction "X" means teleport.
 * The argument is "how#where".
 * The second optional argument is an object to move the player to.
 * If the second argument exists, then the first argument is taken
 * as the movement message only.
 */
move_player(dir_dest, optional_dest_ob) {
  string dir, dest;
  int is_light;

  if (!optional_dest_ob) {
    if (sscanf(dir_dest, "%s#%s", dir, dest) != 2) {
      tell_object(this_object(), "Move to bad dir/dest\n");
      return;
    }
  } else {
    dir = dir_dest;
    dest = optional_dest_ob;
  }
  hunting_time -= 1;
  if (hunting_time == 0) {
    if (hunter)
      call_other(hunter, "stop_hunter");
     hunter = 0;
     hunted = 0;
  }
  if (attacker_ob && present(attacker_ob)) {
    hunting_time = 10;
    if (!hunter)
      tell_object(this_object(), "You are now hunted by " +
                  call_other(attacker_ob, "query_name", 0) + ".\n");
    hunter = attacker_ob;
  }
  if(1) {
    if(!is_invis)
      say("@RMO"+query_idstr()+".@RFS");     /* Remove object from scene */
    if (!msgout)
      msgout = "leaves";
    if (ghost)
      say(NAME_OF_GHOST + " " + msgout + " " + dir + ".\n");
    else if (dir == "X" && !is_invis)
      say(cap_name + " " + mmsgout + ".\n");
    else if (!is_invis)
      say(cap_name + " " + msgout + " " + dir + ".\n");
  }
  move_object(this_object(), dest);
  if (level >= 20) {
    if (!optional_dest_ob)
    tell_object(this_object(), "/" + dest + "\n");
  }
  if(!is_invis)
    say(query_desc()+"@RFS");       /* Show ourselve to new location */
  if (!msgin)
    msgin = "arrives";
  if (ghost)
    say(NAME_OF_GHOST + " " + msgin + ".\n");
  else if (dir == "X" && !is_invis)
    say(cap_name + " " + mmsgin + ".\n");
  else if (!is_invis)
    say(cap_name + " " + msgin + ".\n");
  if (hunted && present(hunted))
    attack_object(hunted);
  if (hunter && present(hunter))
    call_other(hunter, "attack_object", this_object());
  if (is_npc)
    return;
  glance();
  return 1;
}

glance() {
  object ob;

  ob = environment(this_object());
  call_other(ob, "long");
}

magic_move(destination) {
  object source;

  source = environment(this_object());
  /* Introduce ourself to new environment */
  if(!is_invis)
  tell_room(destination, query_desc()+"@RFS"+
    this_object()->query_name()+" suddenly appears right before your eyes.\n");
  /* Actual move */
  move_object(this_object(), destination);
  /* remove from old environment */
  if(!is_invis)
  tell_room(source, "@RMO"+ query_idstr()+".@RFS"+this_object()->query_name()+
    " suddenly disappears right before your eyes.\n");
  /* Show new environment to myself */
  command("look",this_object());
}

/*
 * This function is called from other players when they want to make
 * damage to us. We return how much damage we received, which will
 * change the attackers score. This routine is probably called from
 * heart_beat() from another player.
 * Compare this function to reduce_hit_point(dam).
 */
hit_player(dam) {
  int tmp;

  if (!attacker_ob)
    set_heart_beat(1);
  if (!attacker_ob && this_player() != this_object())
    attacker_ob = this_player();
  else
    if (!alt_attacker_ob && attacker_ob != this_player() &&
        this_player() != this_object())
      alt_attacker_ob = this_player();
  /* Don't damage wizards too much ! */
  if (level >= 20 && !is_npc && dam >= hit_point) {
    tell_object(this_object(),"Your Schepperhood protects you from death.\n");
    return 0;
  }
  if (!is_npc && !query_ip_number(this_object())) {
    write(cap_name+" is frozen. You may not kill frozen players!\n");
    stop_fight();
    if (this_player())
      this_player()->stop_fight();
    return 0;
  }
  if(dead)
    return 0;
  dam -= random(armour_class) + (tough / 12);
  if (dam <= 0)
    return 0;
  if (dam > hit_point+1)
    dam = hit_point+1;
  hit_point = hit_point - dam;
  if (hit_point<0) {
    /* We died! */
    object corpse;
    dead = 1;
    if (hunter) {
      int s;
      call_other(hunter, "stop_hunter");
      s=call_other(hunter, "query_str");
      if (s<100 && !this_object()->query_soft_kill())
        call_other(hunter, "add_str", (100-s)/50);
    }
    hunter = 0;
    hunted = 0;
    say(cap_name+" died.\n");
    call_other(environment(this_object()),"resend_state");
    if (!attacker_ob || !attacker_ob->query_soft_kill()) {
      experience = (experience) / 4;    /* Yes, I've become more cruel. */
      tmp = random(6);
      if (tmp == 0) strength -= random(5 + (level / 4));
      if (tmp == 1) tough -= random(5 + (level / 4));
      if (tmp == 2) dex -= random(5 + (level / 4));
      if (tmp == 3) intel -= random(5 + (level / 4));
      if (tmp == 4) brave -= random(5 + (level / 4));
      if (tmp == 5) social -= random(5 + (level / 4));
      if (strength < 20) strength = 20;
      if (tough < 20) tough = 20;
      if (dex < 20) dex = 20;
      if (intel < 20) intel = 20;
      if (brave < 20) brave = 20;
      if (social < 20) social = 20;
    }
    hit_point = 10;
    /* The player killing us will update his alignment ! */
    if(attacker_ob) {
      call_other(attacker_ob, "add_alignment",ADJ_ALIGNMENT(alignment));
      if (!this_object()->query_soft_kill())
        call_other(attacker_ob, "add_exp", experience / 20);
    }
    corpse = clone_object("obj/corpse");
    call_other(corpse, "set_name", name);
    if (attacker_ob) {
      string n;
      n = attacker_ob->query_real_name();
      if (n)
        call_other(corpse, "set_killed_by", capitalize(n)); 
    }
    transfer_all_to(corpse);
    move_object(corpse, environment(this_object()));
    if (!call_other(this_object(), "second_life", 0))
      {
      tell_room(environment(this_object()),"@RMO"+idstr+"@RFS");
      destruct(this_object());
      }
    if (!is_npc)
      save_object("users/" + name);
  }
  if(!spell_cost) {
    spell_cost=random(level*5);
    if(spell_cost>spell_points) spell_cost=random(spell_points);
    get_spell_name(spell_cost);
  }
  return dam;
}

get_spell_name(dam) {
  spell_name="Big Bang";
  spell_file="bang";
  if(dam<101) {
    spell_name="Total Armageddon";
    spell_file="armageddon";
  }
  if(dam<91) {
    spell_name="Nuclear Attack";
    spell_file="nuke";
  }
  if(dam<81) {
    spell_name="AIDS";
    spell_file="aids";
  }
  if(dam<71) {
    spell_name="Lepra";
    spell_file="lepra";
  }
  if(dam<61) {
    spell_name="Maim";
    spell_file="maim";
  }
  if(dam<51) {
    spell_name="Firebolt";
    spell_file="fire";
  }
  if(dam<41) {
    spell_name="Frost bolt";
    spell_file="frost";
  }
  if(dam<31) {
    spell_name="Storm";
    spell_file="storm";
  }
  if(dam<21) {
    spell_name="fierce wind";
    spell_file="wind";
  }
  if(dam<11) {
    spell_name="gentle breeze";
    spell_file="breeze";
  }
}

transfer_all_to(dest) {
  object ob;
  object next_ob;

  ob = first_inventory(this_object());
  while(ob) {
    next_ob = next_inventory(ob);
    /* Beware that drop() might destruct the object. */
    if (!call_other(ob, "drop", 1) && ob)
      move_object(ob, dest);
    ob = next_ob;
  }
  local_weight = 0;
  if (money == 0)
    return;
  ob = clone_object("obj/money");
  call_other(ob, "set_money", money);
  call_other(ob, "locate", pos,  depth);
  move_object(ob, dest);
  money = 0;
}

query_name() {
  if (ghost)
    return NAME_OF_GHOST;
  return cap_name;
}

query_alignment() {
  return alignment;
}

query_npc() {
  return is_npc;
}

/*
 * This routine is called when we are attacked by a player.
 */
attacked_by(ob) {
  if (!attacker_ob) {
    attacker_ob = ob;
    set_heart_beat(1);
    return;
  }
  if (!alt_attacker_ob) {
    alt_attacker_ob = ob;
    return;
  }
}

show_stats() {
  int i;

  write("The statistics of "+short()+". ");
  write("filename: "+file_name(this_object())+"\n");
  write("level: "+level+"\n");
  write("credits: "+money+"\n");
  write("hp: "+hit_point+"\n");
  write("maxhp: "+max_hp+"\n");
  write("spellpoints: "+spell_points+"\n");
  write("experience: "+experience+"\n");
  write("align: " + alignment + "\n");
  write("gender: "+query_gender_string()+"\n");
  write("weapon: "+weapon_class+"\n");
  write("armour: "+armour_class+"\n");
  write("strength: "+strength+"\n");
  write("toughness: "+tough+"\n");
  write("dexterity: "+dex+"\n");
  write("intelligence: "+intel+"\n");
  write("braveness: "+brave+"\n");
  write("social: "+social+"\n");
  write("carry: "+local_weight+"\n");
  if (attacker_ob)
    write("attack: "+call_other(attacker_ob, "query_name")+"\n");
  if (alt_attacker_ob)
    write("alt attack: "+call_other(alt_attacker_ob, "query_name")+"\n");
  write("Quests: "+call_other(this_object(), "query_quests", 0)+"\n");
  show_age();
  write("\n");
}

/* No weapons, so no wielding
stop_wielding() {
  if (!name_of_weapon) {
    log_file("wield_bug", "Weapon not wielded !\n");
    write("Bug ! The weapon was marked as wielded ! (fixed)\n");
    return;
  }
  call_other(name_of_weapon, "un_wield", dead);
  name_of_weapon = 0;
  weapon_class = WEAPON_CLASS_OF_HANDS;
}
*/

stop_wearing(name) {
  if(!head_armour) {
    /* This should not happen ! */
    log_file("wearing_bug", "armour not worn!\n");
    write("This is a bug, no head_armour\n");
    return;
  }
  head_armour = call_other(head_armour, "remove_link", name);
  if(head_armour && objectp(head_armour))
    armour_class = call_other(head_armour, "tot_ac");
  else {
    armour_class = 0;
    head_armour = 0;
  }
  if (!is_npc)
    if(!dead)
    say(cap_name+" removes "+name+".\n");
    write("Ok.\n");
}

query_level() {
  return level;
}

/* This object is not worth anything in the shop ! */
query_value() { return 0; }

/* It is never possible to pick up a player ! */
get() { return 0; }

/*
 * Return true if there still is a fight.
 */
attack() {
  int tmp,ammo;
  int whit;
  string name_of_attacker;

  if (!attacker_ob) {
    spell_cost = 0;
    return 0;
  }
  if(name_of_weapon)
    ammo=name_of_weapon->query_ammo();
  name_of_attacker = call_other(attacker_ob, "query_name", 0);
  if (!name_of_attacker || name_of_attacker == NAME_OF_GHOST ||
    environment(attacker_ob) != environment(this_object())) {
    if (!hunter&&name_of_attacker&&!call_other(attacker_ob,"query_ghost",0)) {
      tell_object(this_object(),"You are now hunting " +
                  call_other(attacker_ob, "query_name", 0) + ".\n");
      hunted = attacker_ob;
      hunting_time = 10;
    }
    attacker_ob = 0;
    if (!alt_attacker_ob)
      return 0;
    attacker_ob = alt_attacker_ob;
    alt_attacker_ob = 0;
    if (attack()) {
      tell_object(this_object(),
                  "You turn to attack "+attacker_ob->query_name()+".\n");
      return 1;
    }
    return 0;
  }
  if (!is_npc && random(2*brave) < attacker_ob->query_level() &&
        (attacker_ob->query_level() - level) > 5)
  {
    tell_object(this_object(),
      "You are not brave enough to face your opponent this long!\n");
    run_away();
    return 0;
  }
  if (spell_cost) {
    spell_points -= spell_cost;
    say(cap_name+" casts the "+spell_name+" spell.\n",attacker_ob);
    write("You cast the "+spell_name+" spell.\n");
    tell_object(attacker_ob,"You are hit by a "+spell_name+".\n");
     call_other("system/combat","shoot",pos,depth,attacker_ob->query_pos(),attacker_ob->query_depth(),"dummies/"+spell_file);
  }
  if(name_of_weapon)
    whit = call_other(name_of_weapon,"hit",attacker_ob);
  if(whit != -1)
    tmp = call_other(attacker_ob, "hit_player",
                     random(weapon_class+whit+(strength/12))+spell_dam);
  else
    tmp = 0;
write("spell_cost="+spell_cost+"\n");
write("hit="+tmp+"\n");
  if (tmp == 0) {
    tell_object(this_object(), "You missed.\n");
    say(cap_name+" missed "+name_of_attacker + ".\n");
    if (name_of_weapon)
      name_of_weapon->possible_break();
    spell_cost = 0;
    spell_dam = 0;
    return 1;
  }
  experience += tmp;
  spell_cost = 0;
  spell_dam = 0;
  /* Does the enemy still live ? */
  if (attacker_ob && call_other(attacker_ob,"query_name",0) != NAME_OF_GHOST) {
    string how, what;

    what = "completely desintegrates";
    how = "";
    if (tmp < 50) {
      how =  "to pieces";
      what = "rips";
    }
    if (tmp < 40) {
      how = " to small fragments";
      what = "massacre";
    }
    if (tmp < 30) {
      how = "";
      what = "inflicted tremendous damage to";
    }
    if (tmp < 20) {
      how = " very hard";
      what = "hit";
    }
    if (tmp < 10) {
      how = " hard";
      what = "hit";
    }
    if (tmp < 5) {
      how = "";
      what = "hit";
    }
    if (tmp < 3) {
      how = "";
      what = "grazed";
    }
      if (tmp < 2) {
      how = "";
      what = "barely hit";
    }
    tell_object(this_object(), "You "+what+" "+name_of_attacker+how+".\n");
    tell_object(attacker_ob, cap_name+" "+what+" you"+how+".\n");
    say(cap_name+" "+what+" "+name_of_attacker+how+".\n", attacker_ob);
    if (name_of_weapon) name_of_weapon->possible_break();
      return 1;
  } else {
    /* Enemy died! */
    tell_object(this_object(), "You murdered " + name_of_attacker + ".\n");
    attacker_ob = alt_attacker_ob;
    alt_attacker_ob = 0;
  }
  if (attacker_ob)
  return 1;
}

query_attack() {
  return attacker_ob;
}

drop_all_money(verbose) {
  object mon;
  if (money == 0)
    return;
  mon = clone_object("obj/money");
  call_other(mon, "set_money", money);
  call_other(mon, "locate", pos, depth);
  move_object(mon, environment());
  say("@RFS");
  write("@RFS");
  if (verbose) {
    say(cap_name+" drops "+money+" credits.\n");
    tell_object(this_object(), "You drop "+money+" credits.\n");
  }
  money = 0;
}

/* Wield a weapon.NOT
wield(w) {
  if (name_of_weapon)
    stop_wielding();
  name_of_weapon = w;
  weapon_class = call_other(w, "weapon_class", 0);
  say(cap_name+" wields "+call_other(w, "query_name", 0)+".\n");
  write("Ok.\n");
}

query_wielded() { return name_of_weapon; }
*/

query_head_armour() { return head_armour; }

query_local_weight() { return local_weight; }

/* Wear some armour. */
wear(a) {
  object old;

  if(head_armour) {
    old = call_other(head_armour, "test_type", call_other(a, "query_type"));
    if(old)
      return old;
    old = head_armour;
    call_other(a, "link", old);
  }
  head_armour = a;
  /* Calculate new ac */
  armour_class = call_other(head_armour, "tot_ac");
  say(cap_name+" wears "+call_other(a, "query_name", 0)+".\n");
  write("Ok.\n");
  return 0;
}

add_weight(w) {
  if (w + local_weight > level + 10 && level < 20)
    return 0;
  local_weight += w;
  return 1;
}

heal_self(h) {
  if (h <= 0)
    return;
  hit_point += h;
  if (hit_point > max_hp)
    hit_point = max_hp;
  spell_points += h;
  if (spell_points > 2*max_hp)
    spell_points = 2*max_hp;
}

restore_spell_points(h) {
  spell_points += h;
  if (spell_points > 2*max_hp)
    spell_points = 2*max_hp;
}

can_put_and_get(str) {
  return str != 0;
}

attack_object(ob) {
  if (call_other(ob, "query_ghost", 0))
    return;
  set_heart_beat(1);   /* For monsters, start the heart beat */
  if (attacker_ob == ob) {
    attack();
    return;
  }
  if (alt_attacker_ob == ob) {
    alt_attacker_ob = attacker_ob;
    attacker_ob = ob;
    attack();
    return;
  }
  if (!alt_attacker_ob)
    alt_attacker_ob = attacker_ob;
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
  attack();
}

query_ghost() { return ghost; }

zap_object(ob) {
  call_other(ob, "attacked_by", this_object());
  say(cap_name+" uses the Force and emits deadly rays.\n");
  write("You use the Force and blast deadly rays to your victim.\n");
  experience += call_other(ob, "hit_player", 100000);
  write("There is a big clap of thunder.\n");
}

breeze_object(ob) {
  if (spell_points < 10) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(20);
  spell_cost = 10;
  get_spell_name(spell_cost);
  attacker_ob = ob; 
  call_other(attacker_ob, "attacked_by", this_object());
}

wind_object(ob) {
  if (spell_points < 20) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(30);
  spell_cost = 20;
  get_spell_name(spell_cost);
  attacker_ob = ob; 
  call_other(attacker_ob, "attacked_by", this_object());
}

storm_object(ob) {
  if (spell_points < 30) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(40);
  spell_cost = 30;
  get_spell_name(spell_cost);
  attacker_ob = ob; 
  call_other(attacker_ob, "attacked_by", this_object());
}

frost_object(ob) {
  if (spell_points < 40) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(50);
  spell_cost = 40;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

fire_object(ob) {
  if (spell_points < 50) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(70);
  spell_cost = 50;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

maim_object(ob) {
  if (spell_points < 60) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(90);
  spell_cost = 60;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

plague_object(ob) {
  if (spell_points < 70) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(1100);
  spell_cost = 70;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

AIDS_object(ob) {
  if (spell_points < 80) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(130);
  spell_cost = 80;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

nuke_object(ob) {
  if (spell_points < 90) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(150);
  spell_cost = 90;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

armageddon_object(ob) {
  if (spell_points < 100) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(170);
  spell_cost = 100;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}

bang_object(ob) {
  if (spell_points < 120) {
    write("Too low on power.\n");
    return;
  }
  spell_dam = random(200);
  spell_cost = 120;
  get_spell_name(spell_cost);
  attacker_ob = ob;
  call_other(attacker_ob, "attacked_by", this_object());
}


/* If no one is here (except ourself), then turn off the heart beat. */

test_if_any_here() {
  object ob;
  ob = environment();
  if (!ob)
    return;
  ob = first_inventory(environment());
  while(ob) {
    if (ob != this_object() && living(ob) && !call_other(ob, "query_npc"))
    return 1;
    ob = next_inventory(ob);
  }
  return 0;
}

show_age() {
  int i;

  write(" age: ");
  i = age;
  if (i/43200) {
    write(i/43200 + " days ");
    i = i - (i/43200)*43200;
  }
  if (i/1800) {
    write(i/1800 + " hours ");
    i = i  - (i/1800)*1800;
  }
  if (i/30) {
    write(i/30 + " minutes ");
    i = i - (i/30)*30;
  }
  write(i*2 + " seconds.");
}

stop_hunter() {
  hunter = 0;
  tell_object(this_object(), "You are no longer hunted.\n");
}

/*
 * This function remains only because of compatibility, as command() now
 * can be called with an object as argument.
 */
force_us(cmd) {
  if (!this_player() || this_player()->query_level() <= level ||
      query_ip_number(this_player()) == 0) {
        tell_object(this_object(), this_player()->query_name()+
                           " failed to force you to " + cmd + ".\n");
      return;
  }
  command(cmd);
}

/* This is used by the shop etc. */
add_money(m) {
  if(!intp(m)) return;
  money = money + m;
  if (level <= 19 && !is_npc)
    add_worth(m);
}

query_money() {
  return money;
}

query_exp() {
  return experience;
}

query_frog() {
  return frog;
}

frog_curse(arg) {
  if (arg) {
    if (frog)
      return 1;
    tell_object(this_object(), "You turn into a lizard!\n");
    frog = 1;
    return 1;
  }
  tell_object(this_object(), "You turn HUMAN again.\n");
  frog = 0;
  return 0;
}

run_away() {
  object here;
  string dest_dir;
  int i,j;

  here = environment();
  dest_dir = here->query_dest_dir();
  if (dest_dir) {
    i = random(sizeof(dest_dir)/2);
    move_player(dest_dir[(i*2)+1]+"#"+dest_dir[(i*2)]);
  } else {
    j = random(6);
    while(i<6 && here == environment()) {
      i += 1;
      j += 1;
      if (j > 6)
        j = 1;
      if (j == 1) command("east");
      if (j == 2) command("west");
      if (j == 3) command("north");
      if (j == 4) command("south");
      if (j == 5) command("up");
      if (j == 6) command("down");
    }
  }
  if (here == environment()) {
    say(cap_name+" tried, but failed to run away.\n",this_object());
    tell_object(this_object(),"Your legs tried to run away, but failed.\n");
  } else {
    tell_object(this_object(), "Your legs run away with you!\n");
  }
}

query_hp() {
  return hit_point;
}

query_wimpy() {
  return whimpy;
}

query_current_room() {
  return file_name(environment(this_object()));
}

query_spell_points() {
  return spell_points;
}

stop_fight() {
  attacker_ob = alt_attacker_ob;
  alt_attacker_ob = 0;
}

query_wc() {
  return weapon_class;
}

query_ac() {
  return armour_class;
}

reduce_hit_point(dam) {
  hit_point -= dam;
  if (hit_point <= 0)
    hit_point = 1;
  return hit_point;
}

valid_attr(n) {
  if (!intp(n)) {
    write("Illegal parameter.\n");
    return 0;
  }
  return 1;
}

range_attr(n) {
  if (n < 0) n = 0;
/*  if (n > 100) n = 100; */
  return n;
}

add_str(n) {
  if (!valid_attr(n)) return 1;
  strength = range_attr(strength + n);
  return 1;
}

add_tough(n) {
  if (!valid_attr(n)) return 1;
  tough = range_attr(tough + n);
  return 1;
}

add_int(n) {
  if (!valid_attr(n)) return 1;
  intel = range_attr(intel + n);
  return 1;
}

add_dex(n) {
  if (!valid_attr(n)) return 1;
  dex = range_attr(dex + n);
  return 1;
}

add_brave(n) {
  if (!valid_attr(n)) return 1;
  brave = range_attr(brave + n);
  return 1;
}

add_social(n) {
  if (!valid_attr(n)) return 1;
  social = range_attr(social + n);
  return 1;
}

set_str(n) {
  if (!valid_attr(n)) return 1;
  strength = range_attr(n);
  return 1;
}

set_tough(n) {
  if (!valid_attr(n)) return 1;
  tough = range_attr(n);
  return 1;
}

set_int(n) {
  if (!valid_attr(n)) return 1;
  intel = range_attr(n);
  return 1;
}

set_dex(n) {
  if (!valid_attr(n)) return 1;
  dex = range_attr(n);
  return 1;
}

set_brave(n) {
  if (!valid_attr(n)) return 1;
  brave = range_attr(n);
  return 1;
}

set_social(n) {
  if (!valid_attr(n)) return 1;
  social = range_attr(n);
  return 1;
}

query_str() { return strength; }
query_tough() { return tough; }
query_int() { return intel; }
query_dex() { return dex; }
query_brave() { return brave; }
query_social() { return social; }
query_attrav() { return (strength + tough + dex + intel + brave + social)/6; }


/*
 * Flags manipulations. You are not supposed to do this arbitrarily.
 * Every wizard can allocate a few bits from the administrator, which
 * he then may use. If you manipulate bits that you don't know what they
 * are used for, unexpected things can happen.
 */
set_flag(n) {
  if (flags == 0)
    flags = "";
#ifdef LOG_FLAGS
  log_file("FLAGS", name + " bit " + n + " set\n");
  if (previous_object()) {
    if (this_player() && this_player() != this_object() &&
        query_ip_number(this_player()))
      log_file("FLAGS", "Done by " +
      this_player()->query_real_name() + " using " +
      file_name(previous_object()) + ".\n");
  }
#endif
  flags = set_bit(flags, n);
}

test_flag(n) {
  if (flags == 0)
    flags = "";
  return test_bit(flags, n);
}

clear_flag(n) {
  if (flags == 0)
    flags = "";
#ifdef LOG_FLAGS
  log_file("FLAGS", name + " bit " + n + " cleared\n");
  if (previous_object()) {
    if (this_player() && this_player() != this_object() &&
      query_ip_number(this_player()))
    log_file("FLAGS", "Done by "+this_player()->query_real_name()+" using "+
                     file_name(previous_object()) + ".\n");
  }
#endif

  flags = clear_bit(flags, n);
  return 1;
}

query_gender() { return gender; }
query_neuter() { return !gender; }
query_male() { return gender == 1; }
query_female() { return gender == 2; }

set_gender(g) {
  if (g == 0 || g == 1 || g == 2)
    gender = g;
}
set_neuter() { gender = 0; }
set_male() { gender = 1; }
set_female() { gender = 2; }

query_gender_string() {
  if (!gender)
    return "neuter";
  else if (gender == 1)
    return "male";
  else
    return "female";
}

query_pronoun() {
  if (!gender)
    return "it";
  else if (gender == 1)
    return "he";
  else
   return "she";
}

query_possessive() {
  if (!gender)
    return "its";
  else if (gender == 1)
    return "his";
  else
    return "her";
}

query_objective() {
  if (!gender)
    return "it";
  else if (gender == 1)
    return "him";
  else
    return "her";
}
