/*
 * Map.c
 * Suitable for automaticaly mapping a maze, as designed with
 * the Maze-designer utility for BSX-MUDs
 * (c)Nov.1991 Bram Stolk
 */

inherit "obj/xthing.c";

string map,locell,hicell;
int blank;

graph() {
 return("0207076D8E778A7E8188858D8683937B95060F718E7B9382928A877F83788B");
}

short() {
  if (blank)
    return("a sheet of paper (blank)");
  else
    return("a sheet of paper");
}

id(str) {
  return str=="map" || str=="paper" || str=="sheet";
}

get() {
  return 1;
}

change_char(str,nr,new) {
  if (nr==0) {
    return (new+extract(str,1,56));
  }
  if (nr==56) {
    return (extract(str,0,55)+new);
  }
  return (extract(str,0,nr-1)+new+extract(str,nr+1,56));
}

add_left(x,y) {
  map[2*y+0] = change_char(map[2*y+0],3*x,"|");
  map[2*y+1] = change_char(map[2*y+1],3*x,"|");
}

add_down(x,y) {
  if (map[2*y+1][3*x] != '|')
    map[2*y+1] = change_char(map[2*y+1],3*x+0,"_");
  map[2*y+1] = change_char(map[2*y+1],3*x+1,"_");
  map[2*y+1] = change_char(map[2*y+1],3*x+2,"_");
}

fill(x,y,w) {
  blank = 0;
  switch(w&12) {
    case 0 : hicell = "   ";
             locell = "   ";
             break;
    case 8 : hicell = "|  ";
             locell = "|  ";
             break;
    case 4 : hicell = "   ";
             locell = "___";
             break;
    case 12: hicell = "|  ";
             locell = "|__";
             break;
  }

  if (x==0) {
    map[y*2+0] = hicell+extract(map[y*2+0],3,56);
    map[y*2+1] = locell+extract(map[y*2+1],3,56);
  } else {
    if (x==18) {
      map[y*2+0] = extract(map[y*2+0],0,53)+hicell;
      map[y*2+1] = extract(map[y*2+1],0,53)+locell;
      return 1;
    } else {
      map[y*2+0]=
        extract(map[y*2+0],0,3*x-1)+hicell+extract(map[y*2+0],3*(x+1),56);
      map[y*2+1]=
        extract(map[y*2+1],0,3*x-1)+locell+extract(map[y*2+1],3*(x+1),56);
    }
  }
  if ((w&1) && (y>0))
    add_down(x,y-1);
  if ((w&2) && (x<18))
    add_left(x+1,y);
}

reset(arg) {
  int i;
  ::reset(arg);
  if (!arg) {
    map = allocate(26);
    for (i=0; i<25; i++)
      map[i] = "|                                                        ";
    map[25] = "|________________________________________________________";
  }
  blank = 1;
}

long() {
  int j;

  write("_________________________________________________________\n");
  for (j=0; j<26; j++)
    write(map[j]+"|\n");
  return 1;
}

drop() {
  if (!blank) {
    write("The sheet of paper crumbles to dust.\n");
    destruct(this_object());
    return 1;
  }
}
init() {
	add_action("read","read");
}
read(str) {
	if(id(str)) {
		long();
		return 1;
	}
}
