inherit "obj/xthing";

int worn;

graph() {
  return(
"030E0E7F827E827D807E7E807E8280828280837F82818281807F7F7E807E8107067E837F84818481837F827D817D82040C7D837F8380857E85");
}

query_weight() { return 1; }

get() { return 1; }

query_value() {
  return 185;
}

short() {
  if (worn)
    return "A golden ring with a red stone (worn)";
  else
    return "A golden ring with a red stone";
}

long() {
  write(
"The ring is made of heavy gold. It contains a sparkling red gem.\n"+
"But somehow the stone radiates an evil glow.\n");
}

id(str) {
  return str=="ring";
}

init() {
  add_action("wear","wear");
  add_action("remove","remove");
}

wear(str) {
  if (!str) {
    write("What do you want to wear?\n");
    return 1;
  }
  if (str=="ring") {
    if (environment(this_object()) != this_player()) {
      write("You do not have the ring in your possesion.\n");
      write("How could you wear it then?\n");
      return 1;
    }
    if (worn) {
      write("You are already wearing it, dummy.\n");
      return 1;
    }
    write("With hesitation you put the ring on your finger.\n");
    write("The ring gets warm, with a sudden flash, you find yourself somewhere else.\n");
    call_other("/room/maze_driver","enter");
    worn = 1;
    return 1;
  }
}

remove(str) {
  if (!str) {
    write("What do you want to remove?\n");
    return 1;
  }
  if (str=="ring") {
    if (environment(this_object()) != this_player()) {
      write("You do not have the ring in your possesion.\n");
      write("How could you remove it then?\n");
      return 1;
    }
    if (!worn) {
      write("You are not wearing the ring.\n");
      return 1;
    }
    write("You take the ring from your finger.\n");
    write("The ring immediately crumbles to dust.\n");
    write("With a sudden flash, you find yourself somewhere else.\n");
    this_player()->move_player("#room/lake");
    destruct(this_object());
    return 1;
  }
}

reset(arg) {
  ::reset(arg);
  if (!arg)
    worn = 0;
}

drop() {
  if (worn) {
    write("You'll have to remove the ring from your finger first.\n");
    return 1;
  }
}

