#include "/system/sendhex.h"

static int pos,depth;
static string idstr;
string graphic;

reset(arg) {
  string tmp,instance;

  if (!arg) {
    tmp = file_name(this_object());
    /* Assume all instances look alike, and therefore remove the nr */
    sscanf(tmp,"%s#%s",idstr,instance);
    pos = random(16);
    depth = random(8);
  }
}

locate(p,d) {
  depth = d;
  pos = p;
}

query_pos() {
  return pos;
}

query_depth() {
  return depth;
}

query_desc() {
  if((!set_light(0))||(environment(this_object())->query_skip_contents())) return "";
  if(this_object()->query_invis()) return "";
  return("@VIO"+idstr+"."+sendhex(pos)+sendhex(depth));
}

define() {
  if (!idstr)
    return("@DFO"+file_name(this_object())+"."+graph());
  return("@DFO"+idstr+"."+graph());
}


set_idstr(s) {
  object o;

  if (!s)
    return;
  idstr = s;
  if(!environment(this_object())) return;
  o = first_inventory(environment(this_object()));
  while (o) {
    if (living(o) && !o->query_npc())
      command("take_a_new_look",o);
    o = next_inventory(o);
  }
}

query_idstr() {
  return(idstr);
}

purge() {
  object o;
  shout("@PUR"+idstr+".");
  write("@PUR"+idstr+".");
  if(!environment(this_object())) return;
  o = first_inventory(environment(this_object()));
  while (o) {
    if (living(o))
      command("take_a_new_look",o);
    o = next_inventory(o);
  }
}

/*
 * Some objects have instances that do not look alike.
 * E.g. players look different from eachother.
 * If this is the case, then the idstr must include the
 * instance nr.
 */
get_unique_idstr() {
  idstr = file_name(this_object());
}

void clean_up() {
  object o;
  if (interactive(this_object()))
    return;
  if (!environment(this_object())) {
    return;
  }
  o = first_inventory(environment(this_object()));
  while (o) {
    if (interactive(o))
      tell_object(o,"God taketh away "+this_object()->short()+"\n"+
		    "@"+"RMO"+idstr+".@"+"RFS");
    o = next_inventory(o);
  }
  call_out("terminate",1);
}

terminate() {
  destruct(this_object());
}

graph(){
  if(!graphic) return "00";
  return graphic;
}

set_graph(graph) {
  if (graph)
    graphic = graph;
}

set_graphic(g) { set_graph(g); }
