inherit "room/xroom";

int open;
object barrel;

reset(arg) {
  ::reset();
  if (!arg) {
    open = 0;
    graphic=
"0B04080094FF96FFFF00FF0401FF9800980000FF000407503950CF18BC184F040F503950D0E2C3E2430407E244E2C4FFCFFF370403793CBC41BCA579A5040B7D3C7DA0B8A0B840040877927A937A887788040877567A577A4C774C0408B58FC190C088B5880408B55AB551C051C05B";
    description =
"You are standing in the porch of the Terran Research centre on Charon.\n"+
"The construction was designed to withstand 20 Megaton TNT attacks.\n";
    dest_dir = ({
                  "players/bram/charon/research","south"
    });
  }
  if (open)
    close_door();
  if (!present("barrel",this_object())) {
    barrel = clone_object("players/bram/obj/barrel");
    barrel->locate(10,3);
    move_object(barrel,this_object());
  }
}

init() {
  ::init();
  add_action("enter","enter");
  add_action("enter","north");
}

enter() {
  if (!open) {
    write("A huge steel door is blocking your way...\n");
    return 1;
  }
  this_player()->move_player("inside#players/bram/charon/in_rd");
  return 1;
}

query_door() {
  return open;
}

open_door() {
  open = 1;
  idstr="players/bram/dummies/cracked";
  resend_state();
}

close_door() {
  open = 0;
  idstr=file_name(this_object());
  resend_state();
}

nuclear_detonation() {
  shout("BOOM!\n");
  tell_room(this_object(),"@"+"VIOplayers/bram/dummies/blast.0A03@"+"RFS");
  open_door();
}

