/*
 * detonator
 * Bram Stolk, March 92
 */
inherit "obj/xthing";

int timer;
object mass;

id(str) {
  return(str=="detonator" || str=="nuclear detonator");
}

reset(arg) {
  ::reset(arg);
  if (!arg) {
    graphic = 
"0B04018B839583957B8B7B040C91829482947C917C040C8C828F828F7C8C7C040192819381938092800401927E937E937D927D04018D7E8E7E8E7D8D7D04018D818E818E808D8004038B7B957B956E8B6E040B8C798C7794779479040B8C758C7394739475040B8C718C6F946F9471";
  }
  set_heart_beat(1);
  mass = 0;
  timer = 0;
}

short() {
  return("A nuclear detonator");
}

long() {
  write("This device can be installed on a nuclear mass.\n"+
        "The timer currently displays "+timer+" seconds.\n"+
        "You can set the timer with 'set <seconds>'\n");
}

init() {
  add_action("install","install");
  add_action("set","set");
}

install(str) {
  object s;

  if (!str) {
    write("What do you want to install?\n");
    return 1;
  }
  if (str=="detonator") {
    if (mass) {
      write("It is already installed.\n");
      return 1;
    }
    s = first_inventory(environment(this_player()));
    while(s) {
      if (s->id("nuclear mass"))
        mass = s;
      s = next_inventory(s);
    }
    write("You install the detonator to the nuclear mass.\n");
  say(this_player()->query_name()+
      " installs a nuclear detonator to a nuclear mass.\n");
    move_object(this_object(),environment(this_player()));
    pos = 10;
    depth = 2;
    environment(this_player())->resend_state();
    return 1;
  }
}

set(value) {
  int time;
  if (sscanf(value,"%d",time)==1) {
    if (time<0 || time>99) {
      write("The timer can only be set to the range 0-99\n");
      return 1;
    }
    write("You set the timer of the nuclear detonator to "+time+" seconds.\n");
    say(this_player()->query_name()+
        "sets the timer of a nuclear detonator to "+time+" seconds.\n");
    timer = time;
    return 1;
  }
}

query_weight() {
  return 1;
}

query_value() {
  return 75;
}

get() {
  return 1;
}

heart_beat() {
  if (mass) {
    say("Nuclear detonation in "+timer+"seconds!\n");
    if (!timer) {
      destruct(mass);
      call_other("players/bram/charon/gate","nuclear_detonation");
      destruct(this_object());
      return;
    }
    timer--;
  }
}

