/*
 * Intercom.c
 * Bram Stolk, March 92
 */
inherit "obj/xthing";

int state;

id(str) {
  return (str=="intercom");
}

reset(arg) {
  ::reset(arg);
  if (!arg) {
    state = 0;
    graphic = 
"0404037C81838183937C93040B7D8C828C82837D83040C7D927D917E917E9204088193829382A181A1";
  }
}

init() {
  add_action("send","send");
  add_action("activate","activate");
  add_action("deactivate","deactivate");
}

short() {
  if (state)
    return("An intercom (activated)");
  else
    return("An intercom (deactivated)");
}

long() {
  write(
"This intercom is standard equipment in several Terran military services:\n"+
"The Terran Assault troops, Terran Security Guards, Terran Defense Units.\n"+
"You can use it with 'send <string>'\n");
}

send(str) {
  object s;
  object guard;
  string command;

  if (!str) {
    write("What do you want to send over the intercom?\n");
    return 1;
  }
  if (!state) {
    write("The intercom has not been activated yet.\n"+
	  "You are making a fool of yourself.\n");
    say(this_player()->query_name()+" is rather dim-witted.\n");
    return 1;
  }
  say(this_player()->query_name()+" operates an intercom.\n");
  write("You send '"+str+"' over the intercom.\n");
  command = capitalize(str);
  guard = 0;
  s = first_inventory("players/bram/charon/research");
  while (s) {
    if (s->id("guard"))
      guard = s;
    s = next_inventory(s);
  }
  if (!guard) {
    write("However, you receive no response.\n");
    return 1;
  }

  /*
   * Right code
   */
  if (command == "ALPHA UTAH ROMEO") {
    /* Guard exists and right code sent -> remove guard */
    write(
"You receive response from Terran security guard #1209/993: 'Romeo Alpha'.\n");
    tell_room("players/bram/charon/research",
"The Terran guard operates his intercom and leaves south.\n"+"@"+
"RMO"+guard->query_idstr()+".@"+"RFS");
  destruct(guard);
  return 1;
  }

  /*
   * Unappropriate code
   */
  if (command == "ALPHA UTAH ALPHA" ||
      command == "ALPHA UTAH CHARLIE PAPPA") {
    write(
"You receive response from Terran security guard #1209/993: 'Romeo Nevada'.\n");
    return 1;
  }

  /*
   * Unkown code
   */
  write(
"You receive response from Terran security guard #1209/993: 'Pappa Romeo'.\n");
  return 1;
}

/*
 * Deactivate and Activate
 */
activate(str) {
  if (!str) {
    write("Activate what?\n");
    return 1;
  }
  if (str=="intercom") {
    if (state) {
      write("It's already on, dummy.\n");
      return 1;
    }
    write("You activate the intercom.\n");
    say(this_player()->query_name()+" activates an intercom.\n");
    state = 1;
    return 1;
  }
}

deactivate(str) {
  if (!str) {
    write("Deactivate what?\n");
    return 1;
  }
  if (str=="intercom") {
    if (!state) {
      write("It's already off, dummy.\n");
      return 1;
    }
    write("You deactivate the intercom.\n");
    say(this_player()->query_name()+" deactivates an intercom.\n");
    state = 0;
    return 1;
  }
}

query_weight() {
  return 2;
}

query_value() {
  return 55;
}

get() {
  return 1;
}

