inherit "room/xroom";

reset(arg) {
  ::reset();
  if (!arg) {
    graphic=
"08040800540000FF00FF4F040CC31AE429F742E428040CA32AC537DB35C2390C04FF4C794C1C48124207360226031B0A0B2000000000FFFFFF040C274912A528B34549040727494549531B321C0B0F321C341F3E2247224E20521C531A52184C14401236160D0E12A613AE17B31DB721B727B429B02AAA2AA3289F229B1B9A159F";
    description = 
"You are inside a vulcano. There is a beam of light emerging from a hole\n"+
"in the wall. It's the most extraordinairy light you ever saw.\n";
    dest_dir = ({
		  "players/bram/venus/tunnel","east"
    });
    set_heart_beat(1);
  }
}

heart_beat() {
  object o;
  if (random(3)) return;
  o = first_inventory(this_object());
  while (o) {
    if (o->id("magma"))
      transform(o);
    if(o)
      o = next_inventory(o);
  }
}

transform(o) {
  object crumbs,key;
  int p,d;

  p = o->query_pos();
  d = o->query_depth();
  if (p!=4)
    return;
  if (d<5)
    return;
  if (random(3)) {
    say("The rock of magma starts to shiver.\n");
    return;
  }
  say("The rock of magma crumbles to pieces.\n");
  crumbs=clone_object("players/bram/obj/crumbs");
  key=clone_object("players/bram/obj/bronze_key");
  crumbs->locate(p,d);
  key->locate(p,d);
  move_object(crumbs,this_object());
  move_object(key,this_object());
  say(crumbs->query_desc());
  say(key->query_desc());
  say("@RMO"+o->query_idstr()+".@RFS");
  destruct(o);
}


