inherit "room/xroom";

int open;

reset(arg) {
  ::reset();
  if (!arg) {
    open = 0;
    graphic=
"0D04080000003EFF3EFF00040C003DFF3DFFFF00FF050422FF223D0A00000000FF0504DEFFDE3CF700FF00FFFF04087DB57D3D7F3D7FB6040E7DB67D3D583D58A504065B6E7B6E7B415B4104065C747B747BAE5BA0050E7FB7A4A8A43D7F3D7FB7040682AC8275A175A1A40406826C8241A041A06D040E858584798B798A8504088680867B897B8980";
    description = 
"You are inside a vulcano. There is a door leading up north.\n"+
"You get the impression that this space is not nature's work. This room\n"+
"has been created by intelligent lifeforms.\n";
    dest_dir = ({
		  "players/bram/venus/tunnel","south"
    });
  }
  if (open) {
    open = 0;
    resend_state();
  } else
    open = 0;
}

init() {
  ::init();
  add_action("enter","enter");
  add_action("enter","north");
}

enter() {
  if (!open) {
    write("A huge door is blocking your way... You wouldn't happen\n"+
          "to have a key on you, would you?\n");
    return 1;
  }
  this_player()->move_player("inside#players/bram/venus/vault");
  return 1;
}

query_door() {
  return open;
}

open_door() {
  open = 1;
  idstr=file_name(this_object())+"_";
  resend_state();
}

close_door() {
  open = 0;
  idstr=file_name(this_object());
  resend_state();
}
