inherit "room/xroom";
reset(arg) {
	::reset(arg);
	if(arg) return;
	description =	"The banish room.\n"+
			"Players can be banished from here. Banishing means prevent players with\n"+
			"certain names to enter the mud. This is done to make sure that players\n"+
			"don't have the same name as monsters. Only scheppers of level > 23 can\n"+
			"actually banish a name. Other scheppers can just type banish `name`, and\n"+
			"the banish request will be saved in /log/banish-request. Every once in\n"+
			"a while, an arch will look into this file, and banish those names.\n"+
			"When requesting a banish, please give as the reason the filename of the monster.\n"+
			"Syntax: banish [name] [reason]\n";
	graphic = "06040E00FFFFFFFF000000100084DC82DA81D580CD81C883C687C38BC490C592C892CD92D591DA8D"+
		"DF8BE087DF150043D342D240CE3FCA3EC63EC23FBD40BA42B745B648B74BB84FBA4FBD50C251C64F"+
		"CE4ED14CD34CD446D51D003C663D62425C495953566750724F8352955E9D70A581AA87AB82AD73AA"+
		"66A15A9C53964C8A4577436A425F434F46434E3E54365E3566376839681A0020F80EC10A6C183D45"+
		"1E8015AF2EC456CD94C5C0B4EFA2FFAFFFBFF3D1B8D681CF46B11482074409152D025D03A109DA19"+
		"FF25FF07006BB986948689707D6E86809267B5";
}
init() {
	if(this_player()->query_level()>20) {
		if(this_player()->query_level()>23) {
			add_action("banish","banish");
		} else {
			add_action("banish_req","banish");
		}
	}
}
static banish(str) {
	string name,reason;
	if((str)&&(sscanf(str,"%s %s",name,reason)==2)) {
		if(restore_object("users/"+name)) {
			log_file("BANISH",capitalize(this_player()->query_real_name())+" tried to banish "+name+" (player existed)"+"\n");
			write("That player already exists!\n");
			return 1;
		}
		if(file_size("/banish/"+name+".o")>=0) {
			log_file("BANISH",capitalize(this_player()->query_real_name())+" tried to banish "+name+" (already banished)"+"\n");
			write("That player already got banished.\n");
			return 1;
		}
		log_file("BANISH",capitalize(this_player()->query_real_name())+" banished "+name+"\n");
		write_file("/banish/"+name+".o","");
		write("Banished : "+name+"\n");
		return 1;
	}
	write("Usage: banish [player] [reason]\n");
	return 1;
}
static banish_req(str) {
	string name,reason;
	if(str) {
		if(sscanf(str,"%s %s",name,reason)==2) {
			if(restore_object("users/"+name)) {
				write("That player already exists.\n");
				return 1;
			}
			if(file_size("/banish/"+name+".o")>=0) {
				write("That player already got banished.\n");
				return 1;
			}
			log_file("banish-request",capitalize(this_player()->query_real_name())+" wants "+name+" to be banished because of "+reason+"\n");
			write("Banish request for "+name+" has been logged.\n");
			return 1;
		}
	}
	write("Usage: banish [name] [reason]\n");
	return 1;
}
