inherit "room/xroom";
init() {
    ::init();
    add_action("sell", "sell");
    add_action("value", "value");
    add_action("buy", "buy");
    add_action("north", "north");
    add_action("list", "list");
}

reset(arg) {
        if(!present("trashcan")) {
               move_object(clone_object("obj/trashcan"),this_object());
	}
    ::reset(arg);
    if(arg) return;
    dest_dir = ({"room/crossroads","south",
                 "room/storage","west"});
    set_description("You are in a shop. You can buy or sell things here.\n" +
                    "Commands are: 'buy item', 'sell item', 'sell all', 'list', 'list weapons'\n"+
                    "'list armours' and 'value item'.\n" +
                    "There is an opening to the south, and some shimmering\n" +
                    "blue light to the north.\nTo the west you see a small room.\n");
}

sell(item) {
    object ob;

    if (!item)
	return 0;
    if (item == "all") {
	object next;
	ob = first_inventory(this_player());
	while(ob) {
	    next = next_inventory(ob);
	    if (!ob->drop() && ob->query_value()) {
		write(ob->short() + ":\t");
		do_sell(ob);
	    }
	    ob = next;
	}
	write("Ok.\n");
	return 1;
    }
    ob = present(item, this_player());
    if (!ob)
	ob = present(item, this_object());
    if (!ob) {
	write("No such item ("); write(item); write(") here.\n");
	return 1;
    }
    do_sell(ob);
    return 1;
}

static do_sell(ob) {
    int value, do_destroy;
    value = ob->query_value();
    if (!value) {
	write(ob->short() + " has no value.\n");
	return 1;
    }
    if (environment(ob) == this_player()) {
        int weight;
	if (call_other(ob, "drop", 0)) {
	    write("I can't take it from you!\n");
	    return 1;
	}
        weight = call_other(ob, "query_weight", 0);
	call_other(this_player(), "add_weight", - weight);
    }
    if (value > 1000) {
	write("The shop is low on money...\n");
	value = 1000;
    }
    write("You get "); write(value); write(" credits.\n");
    say(call_other(this_player(), "query_name", 0) + " sells " +
	call_other(ob, "short", 0) + ".\n");
    call_other(this_player(), "add_money", value);
    add_worth(value, ob);
    call_other("room/store", "store", ob);
    return 1;
}

value(item) {
    int value;
    string name_of_item;

    if (!item)
	return 0;
    name_of_item = present(item);
    if (!name_of_item)
      name_of_item = present(item,this_player());
    if (!name_of_item) {
        if (call_other("room/store", "value", item))
	    return 1;
	write("No such item ("); write(item); write(") here\n");
	write("or in the store.\n");
	return 1;
    }
    value = call_other(name_of_item, "query_value", 0);
    if (!value) {
	write(item); write(" has no value.\n");
	return 1;
    }
    write("You would get "); write(value); write(" credits.\n");
    return 1;
}

buy(item) {
    if (!item)
	return 0;
    call_other("room/store", "buy", item);
    return 1;
}

north() {
    if (call_other(this_player(), "query_level", 0) < 20) {
	write("A strong magic force stops you.\n");
	say(call_other(this_player(), "query_name", 0) +
	    " tries to go through the field, but fails.\n");
	return 1;
    }
    write("You wriggle through the force field...\n");
    this_player()->move_player("north#room/store");
    return 1;
}

list(obj) {
    call_other("room/store", "inventory", obj);
    return 1;
}
graph() {
	return "18060300572B6CD66CFF4EFF000000040F2B6B2BFF00FF00570400186318C202C50258040FD56BD5FFFFFFFF4E040B2B6BD56BD5FF2AFF0401C06BC0C69BC69B6A1809A875AC6FAF78B877B281B987B48"+
		"CB992B49DB9A1B3A6BAB0B3B5B0C3AAB9A2BBA6AEA0A7A49C9D91A48C9E80A67F9F73040037C283C2839536951A0A33C434C684C686C486B883B67EB77AB778B675B770B465B862B65EB45AB457B655B"+
		"74EB54BB446B745B840B839B534B933B832B50E06689564A162A25DA2529A5198519653955C955B99579A5A9B5A985C9504075B96609560975A9808075EA25EA45DA65CAD65AD64A863A561A20D045BAF5"+
		"BAC5CAC5EAD60AD62AD63AC65AC65AC64AF63AF60AF5DB003095DAA5FAA5FA9030963AA61AA60A803085FA85EA560A5060F6395699E6CAD77AC729D6E95030F77AC6EB170AB040C6CA96AA36EA370A904"+
		"0068956C9F709F6D95040871A96EA271A273A8030870AD72AD70AE040F5FA4629F63A060A4060636953393338E818E83938395";
}
