#define MAX_LIST	30
inherit "room/xroom";
int value;
string name_of_item;

init() {
    add_action("south", "south");
    ::init();
}

inventory(str)
{
    object ob;
    int max;
    if (!str)
	str = "all";
    max = MAX_LIST;
    ob = first_inventory(this_object());
    while(ob && max > 0) {
	if (str == "all") {
	    list(ob);
	    max -= 1;
	}
	if (str == "weapons" && call_other(ob, "weapon_class", 0)) {
	    list(ob);
	    max -= 1;
	}
	if (str == "armours" && call_other(ob, "armour_class", 0)) {
	    list(ob);
	    max -= 1;
	}
	ob = next_inventory(ob);
    }
}

list(ob)
{
    int value;
    
    value = call_other(ob, "query_value", 0);
    if (value) {
	write(value*2 + ":\t" + call_other(ob, "short") + ".\n");
    }
}

value(item) {
    name_of_item = present(item);
    if (!name_of_item) {
	return 0;
    }
    value = call_other(name_of_item, "query_value", 0);
    if (!value) {
	return 0;
    }
    write("The "); write(item); write(" would cost you ");
    write(value*2); write(" credits.\n");
    return 1;
}

buy(item) {
    name_of_item = present(item);
    if (!name_of_item) {
	write("No such item in the store.\n");
	return;
    }
    value = call_other(name_of_item, "query_value", 0);
    if (!value) {
	write("Item has no value.\n");
	return;
    }
    value *= 2;
    if (call_other(this_player(), "query_money", 0) < value) {
	write("It would cost you ");
	write(value); write(" credits, which you don't have.\n");
	return;
    }
    if (!call_other(this_player(), "add_weight",
		    call_other(name_of_item, "query_weight"))) {
	write("You can't carry that much.\n");
	return;
    }
    call_other(this_player(), "add_money", 0 - value);
    add_worth(-value,name_of_item);
    move_object(name_of_item, this_player());
    write("Ok.\n");
    say(call_other(this_player(), "query_name") + " buys " + item + ".\n");
}

south() {
    this_player()->move_player("leaves south#room/shop");
    return 1;
}

reset(arg) {
    if (!present("torch")) {
	object torch;
	torch = clone_object("obj/torch");
	call_other(torch, "set_name", "torch");
	call_other(torch, "set_fuel", 2000);
	call_other(torch, "set_weight", 1);
	move_object(torch, this_object());
    }
    ::reset(arg);
    if(arg) return;
    set_description("All things from the shop are stored here.\n");
    set_graph("11040900FFFFFFFF000000060100413E62CA62FF40FF00000006020F492F49455D458826880D77060295629642B942B9BAB2C494C4040D97589763B9AEB9A1040C1367236C265F16590C0F36BA24AC15"+
		"D627E229DC1CD020CA29CC2AC723C226B735BF070F32E62DE442BE46BF42EB3DE941C70C0F5CC64DC046ED53F155E94BE54DDC54DD54D64ED250C85ACD0B0F65C761CA59F363F86AF76EEC6CE467DF76CD"+
		"71C963DB080F75FA72F880E47FCB83CB86FD81FC80ED080F8BFC8AF694F192CC95CC98F0A0EEA2F50C0FABF2A6F29FCCA3CAA9DCAFD8ABCBAFC9BCEEB7EFB0DEA9E0040FB7C8C4EAC7E6BBC50A0FC3BEB"+
		"FC2CCE3D0E0CFC2DBD9DED5CEB7C8B9CCD3150FE2B5E8B7E9C4E5CBDDCAD5BDD4B6D7AEDBABE0AFDCB9D9B8DCB1D8B2D7B7DAC0DFC5E4C5E5BFE4BBE1B9070961E35DF164F367F169EB68E862E1");
    skip_obvious=1;
    skip_contents=1;
}

store(item)
{
    string short_desc;
    object ob;

    short_desc = call_other(item, "short");
    ob = first_inventory(this_object());
    while(ob) {
	if (call_other(ob, "short") == short_desc) {
	    /* Move it before destruct, because the weight
	       has already been compensated for. */
	    move_object(item, this_object());
	    destruct(item);
	    return;
	}
	ob = next_inventory(ob);
    }
    move_object(item, this_object());
}
