/*
 * New void version which removes the non-player-objects with a period
 * of DEST_TIME seconds.
 * 
 * BSXmud patch by Orion 24-3-1992
 *
 */

#define DEST_TIME 100

inherit "room/xroom";

long() {
	::long();
	call_other(this_player(), "move_player", "out of The Void#room/crossroads");
}

reset(arg)
{
	if (arg) return;
	::reset(arg);
	set_light(1);
	call_out("dest_garbage", DEST_TIME);
	set_description("The Void.\n"+
		  "You come to the void if you fall out of a room, and have nowhere to go.\n"+
		  "Give the command 'out', and you will come back to the crossroads.\n"+
		  "\nYou are transfered to the crossroads...\n");
	dest_dir=({"room/crossroads","out"});
	set_graph("010400000000FFFFFFFF00");
}

dest_garbage()
{
	object item, next;

	remove_call_out("dest_garbage");
	call_out("dest_garbage", DEST_TIME);
	item = first_inventory(this_object());
	while (item) {
		next = next_inventory(item);
		if (item != this_object() && (!living(item) || item->query_npc()))
		destruct(item); 
		item = next;
	}
	return 1;
}
