#define NR_OF_QUESTS 4

string titles;

reset(arg) {
  if (arg) return;
  titles = allocate(12);
  titles[1] = "the Virgin Virtual Novelty";
  titles[2] = "the Discovering Virtual Novelty";
  titles[3] = "the Experienced Virtual Novelty";
  titles[4] = "the Inquisitive virtual Entity";
  titles[5] = "the Resolute Virtual Entity";
  titles[6] = "the Seasoned Virtual Entity";
  titles[7] = "the Junior Virtual Grand Master";
  titles[8] = "the Elder Virtual Grand Master";
  titles[9] = "the Magnificent Virtual Grand Master";
  titles[10]= "the Apprentice Schepper";
  titles[11]= "the Apprentice Schepper with a perfect score";
}

list_levels() {
  int i;

  write("In order to become a Schepper, one needs to solve 90% of the quests.\n");
  write("Currently, there are "+NR_OF_QUESTS+" to solve, ");
  write("from which you solved "+query_percentage(this_player())+"%\n");
  write("To claim your level, pray at the church.\n");
  write("\nsolved               title\n");
  write("--------------------------------------------\n");

  for (i=1; i<=10; i++) {
    write((i-1)+"0"+"-"+i+"0"+"% ");
    if (i<10)
      write(" ");
    write(titles[i]+"\n");
  }
}

query_percentage(p) {
  return (query_nr_of_quests_solved(p)*100)/NR_OF_QUESTS;
}

query_nr_of_quests_solved(p) {
  string q;

  q = p->query_quests();
  if (!q) return 0;
  return
    sizeof(explode(q,"#"));
}

advance(p) {
  int new;

  new = p->query_level()+1;
  if (query_percentage(p) >= (new-1)*10) {
    p->set_level(new);
    p->set_title(titles[new]);
    if(new>9) {
      p->set_level(20);
      log_file("PROMOTIONS",this_player()->query_real_name()+" made it to level 20 at "+ctime(time())+"\n");
    }
    return 1;
  }
  return 0;
}

